<!DOCTYPE html>
<html>
  <body style="font-family: Arial, sans-serif; padding: 20px">
    <h1 style="text-align: center; margin-bottom: 20px">Highest Palindrome</h1>
    <div style="display: flex; justify-content: center">
      <div>
        <div style="margin-bottom: 20px">
          <label
            for="stringInput"
            style="width: 230px; display: inline-block; text-align: right"
            >Input String:</label
          >
          <input
            type="text"
            id="stringInput"
            style="
              margin-left: 10px;
              height: 34px;
              border: 1px solid #d3d3d3;
              padding: 0 10px;
              border-radius: 4px;
            "
          />
        </div>
        <div style="margin-bottom: 20px">
          <label
            for="stringInput"
            style="width: 230px; display: inline-block; text-align: right"
            >Input k:</label
          >
          <input
            type="text"
            id="kInput"
            style="
              margin-left: 10px;
              height: 34px;
              border: 1px solid #d3d3d3;
              padding: 0 10px;
              border-radius: 4px;
            "
          />
        </div>
        <div style="margin-bottom: 20px">
          <label
            for="queryInput"
            style="width: 230px; display: inline-block; text-align: right"
          >
          </label>
          <button onclick="runHighestPalindrome()" style="padding: 10px">
            Result
          </button>
        </div>

        <div
          id="result"
          style="
            margin-top: 20px;
            width: 500px;
            background-color: #efefef;
            border: 1px solid #d3d3d3;
            border-radius: 4px;
            text-align: center;
            height: 50px;
            line-height: 50px;
          "
        ></div>
      </div>
    </div>

    <script>
      function highestPalindrome(str, k) {
        function findHighestPalindrome(s, start, end, k) {
          if (start >= end) {
            return s;
          }

          if (s[start] === s[end]) {
            return findHighestPalindrome(s, start + 1, end - 1, k);
          }

          let firstChar = s[start];
          let lastChar = s[end];

          let maxChar = Math.max(firstChar, lastChar);

          if (k > 0) {
            s[start] = maxChar;
            s[end] = maxChar;
            return findHighestPalindrome(s, start + 1, end - 1, k - 1);
          } else {
            return -1;
          }
        }

        let s = str.split("");

        let result = findHighestPalindrome(s, 0, s.length - 1, k);

        if (
          isNaN(parseInt(result.join(""))) ||
          result.join("") !== result.reverse().join("")
        ) {
          return -1;
        }

        return result.join("");
      }

      function runHighestPalindrome() {
        let stringInput = document.getElementById("stringInput").value;
        let kInput = document.getElementById("kInput").value;
        let result = highestPalindrome(stringInput, kInput);

        document.getElementById("result").innerText = result;
      }
    </script>
  </body>
</html>
